uses dos,crt;
 type
  rifftype=array[0..3]of char;
 const
  riff:rifftype=('R','I','F','F');
  headmask:array[8..$27]of byte=
   ($57,$41,$56,$45,$66,$6d,$74,$20,
    16,0,0,0, 1,0,1,0, 17,43,0,0, 17,43,0,0,
    1,0,8,0, $64,$61,$74,$61);
  savebufsz=16000;
  loadbufsz=16000;
  nctab:array[-31..31]of integer=
  (-8,-7,-7,-7,-7,-7,-7,-7,-7,-7,-6,-6,-6,-6,-6,
  -6,-5,-5,-5,-5,-4,-4,-4,-3,-3,-3,-2,-2,-2,-1,-1,
  0,1,1,2,2,2,3,3,3,4,4,4,5,5,5,5,6,
  6,6,6,6,6,7,7,7,7,7,7,7,7,7,8);
  anctab:array[-8..8]of integer=
  (-31,-22,-16,-12,-9,-6,-3,-1,
  0,1,3,6,9,12,16,22,31);
  vctab:array[-31..31]of integer=
  (-7,-6,-6,-6,-6,-6,-6,-6,-6,-6,-6,-6,-5,-5,
  -5,-5,-5,-5,-5,-4,-4,-4,-4,-4,-3,-3,-3,-2,-2,-1,-1,
  0,1,1,2,2,3,3,3,4,4,4,4,4,5,5,5,5,5,
  5,5,6,6,6,6,6,6,6,6,6,6,6,7);
  avctab:array[-7..7]of integer=
  (-31,-20,-13,-8,-5,-3,-1,0,1,3,5,8,13,20,31);

 var
 DirInfo:SearchRec;
 st:string;
 dir:array[1..24]of string[12];
 c:char;
  fin,fout,fstat:file;
  sta:array[0..255]of word;
  head:array[0..63]of longint;
  s:array[0..63]of word;
  vc,nc,vcn,ncn,tmp,olddc,dc,dc1:integer;
  nc2:integer;
  i,j,k,l,datalen,dataln,xxxxlen:longint;
  a,a1,bs,bz,files:word;
  prev,outbyte:byte;
  b:array[0..1]of byte;{}
  savebuf:array[0..savebufsz-1]of byte;
  savebufpos:word;
  loadbuf:array[0..loadbufsz-1]of word;
  loadbufpos:word;

procedure bflush(var fout:file);
begin
 if savebufpos=0 then exit;
 blockwrite(fout,savebuf,savebufpos);
 savebufpos:=0;
end;

procedure bwrite(var fout:file;x:byte);
begin
 savebuf[savebufpos]:=x;
 inc(savebufpos);
 if savebufpos=savebufsz then bflush(fout);
end;

function bread(var fin:file):word;
begin
 if loadbufpos=loadbufsz then
 begin
  blockread(fin,loadbuf,loadbufsz*2);
  loadbufpos:=0;
 end;
 bread:=loadbuf[loadbufpos];
 inc(loadbufpos);
end;

begin
 FindFirst('*.*', Archive, DirInfo);
{ clrscr;{}
 files:=0;
 while(DosError=0)and(files<24)do
 begin
  if pos('.WAV',dirinfo.name)<>0
  then
   begin
    inc(files);
    dir[files]:=dirinfo.name;
    gotoxy(3,files);
    writeln(DirInfo.Name)
   end;
  FindNext(DirInfo);
 end;
 i:=1;
 j:=1;
 repeat
  gotoxy(1,j);
  write('  ');
  gotoxy(1,i);
  write('->');
  gotoxy(1,i);
  j:=i;
  repeat until keypressed;
  c:=readkey;
  if c=#0
  then begin c:=readkey;
  {gotoxy(20,20);write(c)}
       end;
  case c of
   'q','H':if i>1 then dec(i);
   'a','P':if i<files then inc(i);
  end;{case}
 until c=#13;
 st:=dir[i];
 if st=''
 then st:='s.wav';
 if pos('.',st)=0 then st:=st+'.wav';
  assign(fin,st);
  assign(fout,'smp.smp');
 loadbufpos:=loadbufsz;
 savebufpos:=0;
  reset(fin,1);
  blockread(fin,head,$2c);
  datalen:=head[10]div 4;
  rewrite(fout,1);
{  dataln:=datalen*4;
  xxxxlen:=dataln+$24;
  blockwrite(fout,riff,4);
  blockwrite(fout,xxxxlen,4);
  blockwrite(fout,headmask,32);
  blockwrite(fout,dataln,4);{}
  prev:=128;olddc:=0;
 for i:=0 to 255 do sta[i]:=0;
(*
⥩訩 ଠ:
bs=f(x)=f(x-1)+(b)/2+(b)
bz=f(x+1)=f(x-1)+(b)
 15 ,  17 
*)
  for i:=1 to 4096*255{datalen} {div 2{}{11kHz} do begin
{for IGNORE TRACK feature:}
(*if(i mod 4096)=1{!!!} then prev:=128;olddc:=0;(**)
{11kHz}
(*   a:=((bread(fin)+32768)shr 1+((bread(fin)+32768)shr 1{}))div {256+}128;{}(**)
{from winamp - stereo 44->22}
   a:=((bread(fin)+32768)shr 2+((bread(fin)+32768)shr 2)+(bread(fin)+32768)shr 2+((bread(fin)+32768)shr 2))div {256+}128;(**)
{22kHz}
(*   a:=(bread(fin)+32768)div {256+}128;(**)
   if(a<128)then bs:=0;
   if(a>=128)then bs:=a-128;
   if(a>=384)then bs:=255;
{11kHz}
(*   a1:=((bread(fin)+32768)shr 1+((bread(fin)+32768)shr 1{}))div {256+}128;{}(**)
{from winamp - stereo 44->22}
   a1:=((bread(fin)+32768)shr 2+((bread(fin)+32768)shr 2)+(bread(fin)+32768)shr 2+((bread(fin)+32768)shr 2))div {256+}128;(**)
{22kHz}
(*   a1:=(bread(fin)+32768)div {256+}128;(**)
   if(a1<128)then bz:=0;
   if(a1>=128)then bz:=a1-128;
   if(a1>=384)then bz:=255;

   dc:=bs-prev;dc1:=bz-bs;{}

   nc:={dc1-olddc{}bz-prev{};
   if nc>31 then nc:=31;
   if nc<-31 then nc:=-31;
   ncn:=nctab[nc];
   nc:=anctab[ncn];{}
   nc2:=nc div 2;{div -   SRA, ࠡ⠥  .,    .}
   vc:={dc-(olddc+nc2){}bs-(prev+nc2){};
   if vc>31 then vc:=31;
   if vc<-31 then vc:=-31;
   vcn:=vctab[vc];
   vc:=avctab[vcn];{}
   tmp:={}prev+nc2+vc{};
{   if tmp>255 then b[0]:=255
   else if tmp<0 then b[0]:=0
   else} b[0]:=tmp;
   b[1]:=prev+nc;
  outbyte:=byte(ncn*15+vcn);
{  if(sta[outbyte]<>$ffff)then inc(sta[outbyte]);}
  if(sta[ncn+$40]<>$ffff)then inc(sta[ncn+$40]);
  if(sta[vcn+$80]<>$ffff)then inc(sta[vcn+$80]);
{   bwrite(fout,b[0]);
   bwrite(fout,b[1]);{}
   bwrite(fout,ncn*15+vcn);{}
   prev:=b[1]{bz};
   olddc:=dc1;
  end;
  close(fin);
  bflush(fout);
  close(fout);

  assign(fstat,'stat');
  rewrite(fstat,1);
  blockwrite(fstat,sta,512);
  close(fstat);
 end.